#include <windows.h>
#include "hook.h"


HINSTANCE g_hInst = NULL;
HANDLE hMapHook;


// tbNpAg邱Ƃ烁hCŏ\̂ɂƂ
typedef struct {
    HHOOK hHook;
} HookInfo;
HookInfo *g_pHi = NULL;
const char lpszMapName[] = "musou hook";


BOOL APIENTRY DllMain( HINSTANCE hInst, DWORD dwReason, LPVOID lpReserved ) {

    switch( dwReason ) {
        case DLL_PROCESS_ATTACH:
        case DLL_THREAD_ATTACH:
            g_hInst = hInst;

            // O[otbN͋Lgp
            hMapHook = CreateFileMapping( INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeof(HookInfo), lpszMapName );
            g_pHi = (HookInfo *)MapViewOfFile( hMapHook, FILE_MAP_ALL_ACCESS, 0, 0, 0 );

            break;

        case DLL_PROCESS_DETACH:
        case DLL_THREAD_DETACH:
            if( g_pHi ) {
                UnmapViewOfFile( (LPVOID)g_pHi );
            }
            if( hMapHook ) {
                CloseHandle( hMapHook );
            }
            break;

    }

    return TRUE;
}


LRESULT CALLBACK keyboardProc( int nCode, WPARAM wp, LPARAM lp )
{
    if( nCode < 0 || nCode == HC_NOREMOVE ) {
        return CallNextHookEx( NULL, nCode, wp, lp );
    }

    if( wp ) {
        PKBDLLHOOKSTRUCT pkb = (PKBDLLHOOKSTRUCT)lp;
        switch( pkb->vkCode ) {
            case VK_APPS:
            case VK_LWIN:
            case VK_RWIN:
                return TRUE;
        }
    }

    return CallNextHookEx( NULL, nCode, wp, lp );
}

extern "C" __declspec(dllexport) void setHook() {
    if( g_pHi->hHook ) {
        return;
    }
    g_pHi->hHook = SetWindowsHookEx( WH_KEYBOARD_LL, keyboardProc, g_hInst, 0 );
}


extern "C" __declspec(dllexport) void releaseHook() {
    if( g_pHi->hHook ) {
        UnhookWindowsHookEx( g_pHi->hHook );
    }

    g_pHi->hHook = NULL;
}
